package ex.gt;

import blang.core.ConstantSupplier;
import blang.core.DeboxedName;
import blang.core.IntConstant;
import blang.core.IntVar;
import blang.core.Model;
import blang.core.ModelBuilder;
import blang.core.ModelComponent;
import blang.core.Param;
import blang.inits.Arg;
import blang.inits.DesignatedConstructor;
import blang.types.StaticUtils;
import blang.types.internals.IntScalar;
import ca.ubc.stat.blang.StaticJavaUtils;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Optional;
import java.util.function.Supplier;

@SuppressWarnings("all")
public class SerialInference implements Model {
  public static class Builder implements ModelBuilder {
    private boolean fromCommandLine = false;
    
    @Arg
    public Optional<IntVar> observedMax;
    
    public SerialInference.Builder setObservedMax(final IntVar observedMax) {
      // work around typeRef(..) limitation
      Optional<IntVar> $generated__dummy = null;
      this.observedMax = Optional.of(observedMax);
      return this;
    }
    
    @Arg
    public Optional<IntVar> populationSize;
    
    public SerialInference.Builder setPopulationSize(final IntVar populationSize) {
      // work around typeRef(..) limitation
      Optional<IntVar> $generated__dummy = null;
      this.populationSize = Optional.of(populationSize);
      return this;
    }
    
    @Arg
    public Optional<IntVar> nDraws;
    
    public SerialInference.Builder setNDraws(final IntVar nDraws) {
      // work around typeRef(..) limitation
      Optional<IntVar> $generated__dummy = null;
      this.nDraws = Optional.of(nDraws);
      return this;
    }
    
    public SerialInference build() {
      // For each optional type, either get the value, or evaluate the ?: expression
      IntVar observedMax;
      if (this.observedMax != null && this.observedMax.isPresent()) {
        observedMax = this.observedMax.get();
      } else {
        observedMax = $generated__6();
      }
      final IntVar __observedMax = observedMax;
      IntVar populationSize;
      if (this.populationSize != null && this.populationSize.isPresent()) {
        populationSize = this.populationSize.get();
      } else {
        populationSize = $generated__7(observedMax);
      }
      final IntVar __populationSize = populationSize;
      IntVar nDraws;
      if (this.nDraws != null && this.nDraws.isPresent()) {
        nDraws = this.nDraws.get();
      } else {
        nDraws = $generated__8(observedMax, populationSize);
      }
      final IntVar __nDraws = nDraws;
      // Build the instance after boxing params
      return new SerialInference(
        __observedMax, 
        __populationSize, 
        new ConstantSupplier(__nDraws)
      );
    }
  }
  
  @DesignatedConstructor
  public static SerialInference.Builder builderFromCommandLine() {
    Builder result = new Builder();
    result.fromCommandLine = true;
    return result;
  }
  
  private final IntVar observedMax;
  
  public IntVar getObservedMax() {
    return observedMax;
  }
  
  private final IntVar populationSize;
  
  public IntVar getPopulationSize() {
    return populationSize;
  }
  
  @Param
  private final Supplier<IntVar> $generated__nDraws;
  
  public IntVar getNDraws() {
    return $generated__nDraws.get();
  }
  
  /**
   * Utility main method for posterior inference on this model
   */
  public static void main(final String[] arguments) {
    StaticJavaUtils.callRunner(Builder.class, arguments);
  }
  
  /**
   * Auxiliary method generated to translate:
   * populationSize
   */
  private static IntVar $generated__0(final IntVar observedMax, final IntVar populationSize, final IntVar nDraws) {
    return populationSize;
  }
  
  /**
   * Auxiliary method generated to translate:
   * 0
   */
  private static IntVar $generated__1() {
    return new blang.core.IntConstant(0);
  }
  
  public static class $generated__1_class implements Supplier<IntVar> {
    public IntVar get() {
      return $generated__1();
    }
    
    public String toString() {
      return "0";
    }
    
    public $generated__1_class() {
      
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * 101
   */
  private static IntVar $generated__2() {
    return new blang.core.IntConstant(101);
  }
  
  public static class $generated__2_class implements Supplier<IntVar> {
    public IntVar get() {
      return $generated__2();
    }
    
    public String toString() {
      return "101";
    }
    
    public $generated__2_class() {
      
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * observedMax
   */
  private static IntVar $generated__3(final IntVar observedMax, final IntVar populationSize, final IntVar nDraws) {
    return observedMax;
  }
  
  /**
   * Auxiliary method generated to translate:
   * populationSize
   */
  private static IntVar $generated__4(final IntVar populationSize, final IntVar nDraws) {
    return populationSize;
  }
  
  public static class $generated__4_class implements Supplier<IntVar> {
    public IntVar get() {
      return $generated__4(populationSize, $generated__nDraws.get());
    }
    
    public String toString() {
      return "populationSize";
    }
    
    private final IntVar populationSize;
    
    private final Supplier<IntVar> $generated__nDraws;
    
    public $generated__4_class(final IntVar populationSize, final Supplier<IntVar> $generated__nDraws) {
      this.populationSize = populationSize;
      this.$generated__nDraws = $generated__nDraws;
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * nDraws
   */
  private static IntVar $generated__5(final IntVar populationSize, final IntVar nDraws) {
    return nDraws;
  }
  
  public static class $generated__5_class implements Supplier<IntVar> {
    public IntVar get() {
      return $generated__5(populationSize, $generated__nDraws.get());
    }
    
    public String toString() {
      return "nDraws";
    }
    
    private final IntVar populationSize;
    
    private final Supplier<IntVar> $generated__nDraws;
    
    public $generated__5_class(final IntVar populationSize, final Supplier<IntVar> $generated__nDraws) {
      this.populationSize = populationSize;
      this.$generated__nDraws = $generated__nDraws;
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * fixedInt(60)
   */
  private static IntVar $generated__6() {
    IntConstant _fixedInt = StaticUtils.fixedInt(60);
    return _fixedInt;
  }
  
  /**
   * Auxiliary method generated to translate:
   * latentInt
   */
  private static IntVar $generated__7(final IntVar observedMax) {
    IntScalar _latentInt = StaticUtils.latentInt();
    return _latentInt;
  }
  
  /**
   * Auxiliary method generated to translate:
   * fixedInt(4)
   */
  private static IntVar $generated__8(final IntVar observedMax, final IntVar populationSize) {
    IntConstant _fixedInt = StaticUtils.fixedInt(4);
    return _fixedInt;
  }
  
  /**
   * Note: the generated code has the following properties used at runtime:
   *   - all arguments are annotated with a BlangVariable annotation
   *   - params additionally have a Param annotation
   *   - the order of the arguments is as follows:
   *     - first, all the random variables in the order they occur in the blang file
   *     - second, all the params in the order they occur in the blang file
   * 
   */
  public SerialInference(@DeboxedName("observedMax") final IntVar observedMax, @DeboxedName("populationSize") final IntVar populationSize, @Param @DeboxedName("nDraws") final Supplier<IntVar> $generated__nDraws) {
    this.observedMax = observedMax;
    this.populationSize = populationSize;
    this.$generated__nDraws = $generated__nDraws;
  }
  
  /**
   * A component can be either a distribution, support constraint, or another model  
   * which recursively defines additional components.
   */
  public Collection<ModelComponent> components() {
    ArrayList<ModelComponent> components = new ArrayList();
    
    { // Code generated by: populationSize ~ DiscreteUniform(0, 101)
      // Construction and addition of the factor/model:
      components.add(
        new blang.distributions.DiscreteUniform(
          $generated__0(observedMax, populationSize, $generated__nDraws.get()), 
          new $generated__1_class(), 
          new $generated__2_class()
        )
        );
    }
    { // Code generated by: observedMax | populationSize, nDraws ~ SerialSampling(populationSize, nDraws)
      // Construction and addition of the factor/model:
      components.add(
        new ex.gt.SerialSampling(
          $generated__3(observedMax, populationSize, $generated__nDraws.get()), 
          new $generated__4_class(populationSize, $generated__nDraws), 
          new $generated__5_class(populationSize, $generated__nDraws)
        )
        );
    }
    
    return components;
  }
}
