require("ggplot2")
require("dplyr")

data <- read.csv("/Users/bouchard/w/blogobayes/www/ex/gt/results/all/SerialInference--2117188528/samples/populationSize.csv")

# ggplot has bad default sizes for large facetting
verticalSize <- 2.0 *  1 
horizontalSize <- 4.0

n_samples <- max(data$sample)
cut_off <- n_samples * 0.5
data <- subset(data, sample > cut_off)
normalization <-  length(unique(data$sample))
data <- data %>%
  group_by(value) %>%
  summarise(
    probability = n() / normalization
  )
hdi_upper <- function(samples) {
	n = length(samples)
	m = as.integer(0.9 * n)
	sorted_samples <- sort(samples)
  shortest_length <- Inf
  shortest_interval <- c()
  for (i in 1:(n-m)){
    lower <- sorted_samples[i]
    upper <- sorted_samples[i+m]
    interval_length <- upper - lower
    if (interval_length < shortest_length) {
      shortest_length <- interval_length
      shortest_interval <- c(lower, upper)
    }
  }
return (shortest_interval[2])
}
hdi_lower <- function(samples) {
	n = length(samples)
	m = as.integer(0.9 * n)
	sorted_samples <- sort(samples)
  shortest_length <- Inf
  shortest_interval <- c()
  for (i in 1:(n-m)){
    lower <- sorted_samples[i]
    upper <- sorted_samples[i+m]
    interval_length <- upper - lower
    if (interval_length < shortest_length) {
      shortest_length <- interval_length
      shortest_interval <- c(lower, upper)
    }
  }
return (shortest_interval[1])
}
hdi_df <- data %>% group_by() %>%
 summarise(HDI.lower=hdi_lower(value),
           HDI.upper=hdi_upper(value))


p <- ggplot(data, aes(x = value, y = probability, xend = value, yend = rep(0, length(probability)))) +
  geom_point() + geom_segment() + 
  geom_segment(data = hdi_df, aes(x=HDI.lower, xend=HDI.upper, y=0, yend=0), col="red") + 
  theme_bw() + 
  xlab("populationSize") +
  ylab("probability") +
  ggtitle("Probability mass function plot for: populationSize")
ggsave("/Users/bouchard/w/blogobayes/www/ex/gt/results/all/SerialInference--2117188528/posteriorPlots/populationSize.pdf", limitsize = F, height = verticalSize, width = horizontalSize)
